﻿using System.Text;
using com.upay.utils;
using Newtonsoft.Json;

namespace com.upay.Declaration
{
    public class BillingOrder : RequestObject
    {
        
        /// <summary>
        /// 商家ID
        /// </summary>
        [JsonProperty(PropertyName = "merchantId")]
        public string MerchantId { get; set; }

        /// <summary>
        /// 订单号
        /// </summary>
        [JsonProperty(PropertyName = "requestId")]
        public string RequestId { get; set; }

        /// <summary>
        /// 二级商户编号 
        /// </summary>
        [JsonProperty(PropertyName = "subMerchantId")]
        public string SubMerchantId { get; set; }

        /// <summary>
        /// 计费模式
        /// </summary>
        [JsonProperty(PropertyName = "billingMode")]
        public string BillingMode { get; set; }

        /// <summary>
        /// 收费类型 
        /// </summary>
        [JsonProperty(PropertyName = "feeType")]
        public string FeeType { get; set; }

        /// <summary>
        /// 收费值 
        /// </summary>
        [JsonProperty(PropertyName = "feeValue")]
        public string FeeValue { get; set; }

        /// <summary>
        /// 最小收费金额
        /// </summary>
        [JsonProperty(PropertyName = "minFeeAmout")]
        public string MinFeeAmout { get; set; }

        /// <summary>
        /// 最大收费金额
        /// </summary>
        [JsonProperty(PropertyName = "maxFeeAmount")]
        public string MaxFeeAmount { get; set; }

        /// <summary>
        /// 签名
        /// </summary>
        [JsonProperty(PropertyName = "hmac")]
        public string Hmac{ get; set; }
       
    }
}
