﻿using Newtonsoft.Json;

namespace com.upay.Entity
{
    public class DeclarationSubMerchantCertificate
    {
        /// <summary>
        /// 签约身份
        /// </summary>
        [JsonProperty(PropertyName = "registerRole")]
        public string RegisterRole { get; set; }
        /// <summary>
        /// 营业执照照片路径
        /// </summary>
        [JsonProperty(PropertyName = "businessLicensePath")]
        public string BusinessLicensePath { get; set; }

        /// <summary>
        /// 开户许可证照片路径
        /// </summary>
        [JsonProperty(PropertyName = "openAccountPath")]
        public string OpenAccountPath { get; set; }

        /// <summary>
        /// 法人证件正面照路径
        /// </summary>
        [JsonProperty(PropertyName = "legalIdCardProsPath")]
        public string LegalIdCardProsPath { get; set; }

        /// <summary>
        /// 法人证件反面照路径
        /// </summary>
        [JsonProperty(PropertyName = "legalIdCardConsPath")]
        public string LegalIdCardConsPath { get; set; }

        /// <summary>
        /// 结算卡照片路径
        /// </summary>
        [JsonProperty(PropertyName = "settleBankCardPath")]
        public string SettleBankCardPath { get; set; }

        /// <summary>
        /// 其他资质文件路径
        /// </summary>
        [JsonProperty(PropertyName = "otherCerPath")]
        public string OtherCerPath { get; set; }

        /// <summary>
        /// 法人姓名
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// 法人证件类型
        /// </summary>
        [JsonProperty(PropertyName = "idType")]
        public string IdType { get; set; }

        /// <summary>
        /// 法人证件号
        /// </summary>
        [JsonProperty(PropertyName = "idNo")]
        public string IdNo { get; set; }

        /// <summary>
        /// 法人证件有效期开始日期
        /// </summary>
        [JsonProperty(PropertyName = "effectiveDateStart")]
        public string EffectiveDateStart { get; set; }

        /// <summary>
        /// 法人证件有效期结束日期
        /// </summary>
        [JsonProperty(PropertyName = "effectiveDateEnd")]
        public string EffectiveDateEnd { get; set; }
    }
}
